//Original C source is found per following URL
//http://www.fit.ac.jp/elec/7_online/lu/sample/bmp_image_proc.cpp

`define Y_SIZE 2048	// łő摜
`define X_SIZE 2048

`define HIGH   255	//@摜̍ő勭xl
`define LOW      0	//@摜̍ŏxl
`define LEVEL  256	//@摜̋xxl

module bmp_test;
parameter read_filename="3port.bmp";
parameter write_filename1="after_abc1.bmp";
parameter write_filename2="after_abc2.bmp";
parameter write_filename3="after_abc3.bmp";
parameter [7:0] INTENSITY=100;//0-255

integer  biCompression,       
      biSizeImage,
      biXPelsPerMeter,
      biYPelsPerMeter,
      biClrUsed, 
      biClrImportant;

reg [15:0]  bfType;
integer bfSize;
reg [15:0]   bfReserved1,      bfReserved2;
integer  bfOffBits;
integer  biSize,   biWidth, biHeight;
reg [15:0] biPlanes,    biBitCount;


reg [7:0] image_in [0:`Y_SIZE][0:`X_SIZE][0:2];	// ̓J[摜z
reg [7:0] image_out [0:`Y_SIZE][0:`X_SIZE][0:2];	//o̓J[摜z
reg [7:0] image_bw [0:`Y_SIZE][0:`X_SIZE];		//ZW摜z


//********************************************
//   24Bitrbg}bvt@Cǂݍ       *
//********************************************


task readBMP(input [128*8:1] read_filename);
	integer fp;
	integer  i, j, k;
	reg [7:0] byte;
	begin	
		// t@CI[v
		fp = $fopen(read_filename, "rb") ;//must be binary read mode
		if (!fp) begin
			$display("readBmp: Open error!\n");
			$finish;
		end
		$display("input file : %s\n", read_filename);

		// wb_[ǂݍ
		$fread(bfType,  fp);
		$fread(bfSize,  fp);
		$fread(bfReserved1, fp);
		$fread(bfReserved2, fp);
		$fread(bfOffBits,  fp);

		$fread(biSize,  fp);
		$fread(biWidth, fp);
		if (biWidth%4) begin
			$display("Sorry, biWidth%4 must be zero in this program. Found =%d",biWidth);
			$finish;
		end
		$fread(biHeight, fp);
		$fread(biPlanes, fp);
		$fread(biBitCount,  fp);
		if (biBitCount !=24) begin
			$display("Sorry, biBitCount must be 24 in this program. Found=%d",biBitCount);
			$finish;
		end
		$fread(biCompression,  fp);
		$fread(biSizeImage,  fp);
		$fread(biXPelsPerMeter, fp);
		$fread(biYPelsPerMeter, fp);
		$fread(biClrUsed,  fp);
		$fread(biClrImportant,  fp);

	// RGB摜f[^ǂݍ
		for (i=0; i<  biHeight; i=i+1) begin
			for (j=0; j<  biWidth; j=j+1) begin
				for (k=0; k<3; k=k+1) begin
					$fread(byte,fp);
					image_in[biHeight-i][j][2-k]=byte;
				end
			end
		end
		$display("Current POS=%d",$ftell(fp));
		$fclose(fp);
	end
endtask


//******************************************************
//   24rbg-rbg}bvf[^BMPt@Cɏo    *
//******************************************************

task writeBMP(input [128*8:1] write_filename,input O);
	integer fp;
	integer  i, j, k;
	
	begin
	// t@CI[v 
		fp = $fopen(write_filename, "wb");//must be binary read mode
		if (!fp) begin
			$display("writeBmp: Open error!\n");
			$finish;
		end
		$display("output file : %s\n", write_filename);

	// wb_[ 
		$fwrite(fp,"%u",bfType);
		$fwrite(fp,"%u",bfSize);
		$fwrite(fp,"%u",bfReserved1);
		$fwrite(fp,"%u",bfReserved2);
		$fwrite(fp,"%u",bfOffBits);

		$fwrite(fp,"%u",biSize);
		$fwrite(fp,"%u",biWidth);
		$fwrite(fp,"%u",biHeight);
		$fwrite(fp,"%u",biPlanes);
		$fwrite(fp,"%u",biBitCount);
		$fwrite(fp,"%u",biCompression);
		$fwrite(fp,"%u",biSizeImage);
		$fwrite(fp,"%u",biXPelsPerMeter);
		$fwrite(fp,"%u",biYPelsPerMeter);
		$fwrite(fp,"%u",biClrUsed);
		$fwrite(fp,"%u",biClrImportant);

	// rbg}bvf[^ 
		for (i=0; i< biHeight; i=i+1) begin
			for (j=0; j< biWidth; j=j+1) begin
				for (k=0; k<3; k=k+1)  begin
					if (O) $fwrite(fp,"%u",image_out[biHeight-i][j][2-k]);
				      else $fwrite(fp,"%u",image_in[biHeight-i][j][2-k]);
				end
			end
		end
		$display("Current WPOS=%d",$ftell(fp));
		$fclose(fp);
	end
endtask



//**********************************************
// qfaJ[摜256~ZW摜֕ϊ *
//**********************************************

task BMPto256BW;
	integer y, x, a;
	begin
		for (y=0; y<biHeight; y=y+1) begin
			for (x=0; x<biWidth; x=x+1) begin
				a =$rtoi(0.3*image_in[y][x][0] + 0.59*image_in[y][x][1] + 0.11*image_in[y][x][2]);
				if (a<`LOW) a = `LOW;
				if (a>`HIGH) a = `HIGH;
				image_bw[y][x] = a;
			end
		end
	end
endtask



//****************************************
// 摜24bitrbg}bv`ɕϊ *
//****************************************
task BWto24BMP;
	integer  y, x, a;
	begin
		for (y=0; y<biHeight; y=y+1) begin
			for (x=0; x<biWidth; x=x+1) begin
				a = image_bw[y][x];
				image_out[y][x][0] = a;
				image_out[y][x][1] = a;
				image_out[y][x][2] = a;
			end
		end
	end
	
endtask



//****************************************
// 摜̂Ql                      *
//****************************************
task toBinary( input [7:0] intensity);
	
	integer y, x;
	begin

		for (y=0; y<biHeight; y=y+1)begin
			for (x=0; x<biWidth; x=x+1) begin
				if(image_bw[y][x] >= intensity)	image_bw[y][x]=`HIGH;
				else image_bw[y][x] = `LOW;
			end
		end
	end
endtask


initial begin

	
	//摜1F
	readBMP(read_filename);	  // 摜̓,RGB24rbgJ[BMP摜zɊi[
	writeBMP(write_filename1,0);//ϊŏ

	//摜QFϊ
	BMPto256BW; // qfaJ[摜𔒍摜ɕϊ
	BWto24BMP; //@P`l摜R`laloWtH[}bg֕ϊ
	writeBMP(write_filename2,1);		// 摜o

	//摜RF 2l
	toBinary(INTENSITY);
	BWto24BMP;
	writeBMP(write_filename3,1);		// 摜o

end

endmodule