`line 1 "F:\workveritakwin\veritakwin\regression_test\fileio\bmp_test.v"







module bmp_test;
parameter read_filename="abc.bmp";
parameter write_filename1="after_abc1.bmp";
parameter write_filename2="after_abc2.bmp";
parameter write_filename3="after_abc3.bmp";
parameter [7:0] INTENSITY=100;

integer  biCompression,       
      biSizeImage,
      biXPelsPerMeter,
      biYPelsPerMeter,
      biClrUsed, 
      biClrImportant;

reg [15:0]  bfType;
integer bfSize;
reg [15:0]   bfReserved1,      bfReserved2;
integer  bfOffBits;
integer  biSize,   biWidth, biHeight;
reg [15:0] biPlanes,    biBitCount;


reg [7:0] image_in [0: 1600][0: 1200][0:2];	
reg [7:0] image_out [0: 1600][0: 1200][0:2];	
reg [7:0] image_bw [0: 1600][0: 1200];		

reg [7:0]  data_rgb[0: 1600][0: 1200][0:2];	








task readBMP(input [128*8:1] read_filename);
	integer fp;
	integer  i, j, k;
	reg [7:0] byte;
	begin	
		
		fp = $fopen(read_filename, "rb") ;
		if (!fp) begin
			$display("readBmp: Open error!\n");
			$finish;
		end
		$display("input file : %s\n", read_filename);

		
		$fread(bfType,  fp);
		$fread(bfSize,  fp);
		$fread(bfReserved1, fp);
		$fread(bfReserved2, fp);
		$fread(bfOffBits,  fp);

		$fread(biSize,  fp);
		$fread(biWidth, fp);
		$fread(biHeight, fp);
		$fread(biPlanes, fp);
		$fread(biBitCount,  fp);
		$fread(biCompression,  fp);
		$fread(biSizeImage,  fp);
		$fread(biXPelsPerMeter, fp);
		$fread(biYPelsPerMeter, fp);
		$fread(biClrUsed,  fp);
		$fread(biClrImportant,  fp);

	
		for (i=0; i<  biHeight; i=i+1) begin
			for (j=0; j<  biWidth; j=j+1) begin
				for (k=0; k<3; k=k+1) begin
					$fread(byte,fp);
					image_in[biHeight-i][j][2-k]=byte;
				end
			end
		end
		$fclose(fp);
	end
endtask









task writeBMP(input [128*8:1] write_filename,input O);
	integer fp;
	integer  i, j, k;
	
	begin
	
		fp = $fopen(write_filename, "wb");
		if (!fp) begin
			$display("writeBmp: Open error!\n");
			$finish;
		end
		$display("output file : %s\n", write_filename);

	
		$fwrite(fp,"%u",bfType);
		$fwrite(fp,"%u",bfSize, fp);
		$fwrite(fp,"%u",bfReserved1, fp);
		$fwrite(fp,"%u",bfReserved2, fp);
		$fwrite(fp,"%u",bfOffBits, fp);

		$fwrite(fp,"%u",biSize,  fp);
		$fwrite(fp,"%u",biWidth, fp);
		$fwrite(fp,"%u",biHeight, fp);
		$fwrite(fp,"%u",biPlanes, fp);
		$fwrite(fp,"%u",biBitCount, fp);
		$fwrite(fp,"%u",biCompression,  fp);
		$fwrite(fp,"%u",biSizeImage,  fp);
		$fwrite(fp,"%u",biXPelsPerMeter,  fp);
		$fwrite(fp,"%u",biYPelsPerMeter,  fp);
		$fwrite(fp,"%u",biClrUsed,  fp);
		$fwrite(fp,"%u",biClrImportant, fp);

	
		for (i=0; i< biHeight; i=i+1) begin
			for (j=0; j< biWidth; j=j+1) begin
				for (k=0; k<3; k=k+1)  begin
					if (O) $fwrite(fp,"%u",image_out[biHeight-i][j][2-k]);
				      else $fwrite(fp,"%u",image_in[biHeight-i][j][2-k]);
				end
			end
		end
	
		$fclose(fp);
	end
endtask









task BMPto256BW;
	integer y, x, a;
	begin
		for (y=0; y<biHeight; y=y+1) begin
			for (x=0; x<biWidth; x=x+1) begin
				a =$rtoi(0.3*image_in[y][x][0] + 0.59*image_in[y][x][1] + 0.11*image_in[y][x][2]);
				if (a< 0) a =  0;
				if (a> 255) a =  255;
				image_bw[y][x] = a;
			end
		end
	end
endtask







task makeFIT;
    integer y, x;
    begin

	
	for (y=20; y<=40; y=y+1) begin
		for (x=20; x<=70; x=x+1) begin
			image_in[y][x][0] = 255;
			image_in[y][x][1] = 0;
			image_in[y][x][2] = 0;
		end
	end	
	for (y=70; y<=90; y=y+1) begin
		for (x=20; x<=70; x=x+1) begin
			image_in[y][x][0] = 255;
			image_in[y][x][1] = 0;
			image_in[y][x][2] = 0;
		end
	end
	
	for (y=40; y<=140; y=y+1) begin
		for (x=20; x<=35; x=x+1) begin
			image_in[y][x][0] = 255;
			image_in[y][x][1] = 0;
			image_in[y][x][2] = 0;
		end
	end

	
	for (y=20; y<=140; y=y+1) begin
		for (x=90; x<=110; x=x+1) begin
			image_in[y][x][0] = 0;
			image_in[y][x][1] = 255;
			image_in[y][x][2] = 0;
		end
	end
	

	
	for (y=20; y<=40; y=y+1) begin
		for (x=130; x<=180; x=x+1) begin
			image_in[y][x][0] = 255;
			image_in[y][x][1] = 255;
			image_in[y][x][2] = 0;
		end
	end
	
	for (y=40; y<=140; y=y+1) begin
		for (x=145; x<=165; x=x+1)  begin
			image_in[y][x][0] = 255;
			image_in[y][x][1] = 255;
			image_in[y][x][2] = 0;
		end
	end
  end
endtask







task BWto24BMP;
	integer  y, x, a;
	begin
		for (y=0; y<biHeight; y=y+1) begin
			for (x=0; x<biWidth; x=x+1) begin
				a = image_bw[y][x];
				image_out[y][x][0] = a;
				image_out[y][x][1] = a;
				image_out[y][x][2] = a;
			end
		end
	end
	
endtask









task toBinary( input [7:0] intensity);
	
	integer y, x;
	begin

		for (y=0; y<biHeight; y=y+1)begin
			for (x=0; x<biWidth; x=x+1) begin
				if(image_bw[y][x] >= intensity)	image_bw[y][x]= 255;
				else image_bw[y][x] =  0;
			end
		end
	end
endtask





















initial begin

	
	
	readBMP(read_filename);	  

	
	makeFIT;	
	writeBMP(write_filename1,0);		

	
	BMPto256BW; 
	BWto24BMP; 
	writeBMP(write_filename2,1);		

	
	toBinary(INTENSITY);
	BWto24BMP;
	writeBMP(write_filename3,1);		

end

endmodule


